/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.beans.PropertyVetoException;
import java.io.IOException;
import javax.swing.KeyStroke;
import objets.CMathGrafDoc;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import mathgraph32.MtgMenuFileItem;

@SuppressWarnings("serial")
public class ActionFichierNouvelleFigure extends MtgAction {
	public ActionFichierNouvelleFigure(MtgFrame frameInit) {
		super(frameInit, null, getString("menuFichierNouvelleFigure"),
				getString("tipFichierNouvelleFigure"), iconeAssociee(), KeyStroke.getKeyStroke("control N"), true);
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		// Modification version 3.5 : Si la prcdente fentre a t maximise, on maximise la nouvelle
		MtgInternalFrame cadreActif = frame.cadreActif();
		boolean maximise = cadreActif == null ? false : cadreActif.isMaximum();		
		CMathGrafDoc doc = new CMathGrafDoc(frame);
		doc.listePrincipale.uniteAngle = frame.pref_angleUnit;
		doc.listePrincipale.ajouteConstantePi();
		doc.listePrincipale.ajouteSegmentLongueurUnite(MtgInternalFrame.largeurNouvelleFigure, MtgInternalFrame.hauteurNouvelleFigure);
		MtgInternalFrame cadre = new MtgInternalFrame(frame, "MathGraph" + Integer.toString(frame.instanceNouvelleFenetre()), doc,
				MtgInternalFrame.largeurNouvelleFigure, MtgInternalFrame.hauteurNouvelleFigure);
		Dimension sizefen = new Dimension(cadre.getWidth(), cadre.getHeight());
		try {
			cadre.gestionnaire.initialise();
		} catch (IOException e1) {}
		// frame.metAJourIconesEtMenus(cadre.document); // Version 4.1.2 : Inutile car fait dans MtgInternalFrame.internalFrameActivated
		frame.mtgDesktopPane.add(cadre);
		if (maximise) {
			try {
				cadre.setMaximum(true);
			} catch (PropertyVetoException e1) {
				frame.mtgDesktopPane.getDesktopManager().maximizeFrame(cadre);
			}
		}
		else {
			// Modification version 3.5.1
			frame.mtgDesktopPane.getDesktopManager().activateFrame(cadre);
			try {
				cadre.setSelected(true);
			} catch (PropertyVetoException e1) {
			}
			frame.preparePositionPourFenenetre(sizefen);
			cadre.setLocation(frame.xfenetre, frame.yfenetre);
		}
		frame.activeOutilCapture();
		// On cre si ncessaire un item de menu dans le menu Fenetres pour activer cete fentre
		int nfen = frame.nombreCadresOuverts();
		if (nfen <= MtgFrame.nombreFenetresDansMenu) {
			MtgMenuFileItem item = new MtgMenuFileItem(cadre);
			frame.menuFenetre.add(item);
		}
		else if (nfen == MtgFrame.nombreFenetresDansMenu + 1) frame.menuFenetre.add(frame.itemChoixFenetre);
	}
	
  public static String iconeAssociee() {
    return "images/New24";   
  }
}