/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package actions;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.io.IOException;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import mathgraph32.MtgMenuFileItem;
import objets.CMathGrafDoc;
import types.NatureObjet;

/**
 * Ajout version 5.0 : Sert  charger une figure toute faite
 * @author yvesb
 *
 */
@SuppressWarnings("serial")
public class ActionFichierNouvelleFigureBase extends MtgActionToujoursActivable {
	String nomFichier;
	public ActionFichierNouvelleFigureBase(MtgFrame frameInit, String nomFichierInit) {
		super(frameInit, null, getString(nomFichierInit), null, null, null, false);
		nomFichier = nomFichierInit;
	}
		
  @Override
  public void actionPerformed(ActionEvent e) {
  	String ch = MtgFrame.screenIsHighResolution ? "HD" : "";
  	CMathGrafDoc doc = frame.chargeDocumentDansDossierMtgFrame(frame.pref_langage + "/" + nomFichier + ch + ".mgj");
		MtgInternalFrame cadre = new MtgInternalFrame(frame, "MathGraph" + Integer.toString(frame.instanceNouvelleFenetre()), doc, doc.sizeWindowx, doc.sizeWindowy);
		try {
			cadre.gestionnaire.initialise();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		frame.mtgDesktopPane.add(cadre);
		frame.mtgDesktopPane.getDesktopManager().activateFrame(cadre);
		try {
			cadre.setSelected(true);
		} catch (java.beans.PropertyVetoException err) {
		};
		frame.preparePositionPourFenenetre(new Dimension(cadre.getWidth(), cadre.getHeight()));
		cadre.setLocation(frame.xfenetre, frame.yfenetre);
		// On cre un item de menu dans le menu Fenetres pour activer cete fentre
		MtgMenuFileItem item = new MtgMenuFileItem(cadre);
		frame.menuFenetre.add(item);
		frame.metAJourBoutonsBarreHorizontale(cadre.document);
		if (cadre.listePr.nombreObjetsParNature(NatureObjet.NMacro) != 0) frame.activeOutilExecutionMacro();
		else frame.activeOutilCapture();
		frame.metAJourBoutonsBarreOutils(doc);
		frame.validate();
  }

}
