/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.io.File;
import java.net.URI;

import javax.swing.KeyStroke;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class ActionHelpHelp extends MtgAction {
	public ActionHelpHelp(MtgFrame frameInit) {
		super(frameInit, null, getString("menuHelpHelp") , null, null, KeyStroke.getKeyStroke("F1"), false);
	}
	
	// Ajout version 4.3 pour que l'outil puisse tre activ ou non
  @Override
  public int idMenu() {
    return 32022;
  }	

	@Override
	public void actionPerformed(ActionEvent e) {
		if(Desktop.isDesktopSupported()){		
			if(Desktop.getDesktop().isSupported(Desktop.Action.BROWSE)){
		    String path = frame.pathJar();
		    // Si la langue systme n'est pas supporte, l'aide sera en Anglais
				try {
					String path2 = path + frame.pref_langage + "/CHM/MathGraph32Help.chm";
					File file = new File(path2);
					Desktop.getDesktop().open(file);
				} catch (Exception e1) {
					String chURL = "http://mathgraph32.org/ftp/Help/";
					if (frame.pref_langage.equals("fra")) chURL = chURL + "Helpfra/MathGraph32Help.htm";
					else
					if (frame.pref_langage.equals("eng")) chURL = chURL + "Helpeng/MathGraph32Help.htm";
					else
					if (frame.pref_langage.equals("esp")) chURL = chURL + "Helpesp/MathGraph32Help.htm";
					if(Desktop.getDesktop().isSupported(Desktop.Action.BROWSE)) {
						try { 
							Desktop.getDesktop().browse(new URI(chURL));
						} catch (Exception e3) {
							messageErreur();
						}
					}
				}
			}
		}
	}
	
	private void messageErreur() {
		frame.dialogueAvertissement(getString("ch157"));
	}
}