/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Dimension;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import objets.CElementGraphique;
import types.NatureCalcul;
import types.NatureObjet;

import mathgraph32.MtgFrame;
// Ajout version 4.9.2

@SuppressWarnings("serial")
public class HTMLInfoDlg extends MtgDlg {
	private CElementGraphique objet;
  private MtgButton btnOK;
  private MtgTextArea textArea;
  public HTMLInfoDlg(MtgFrame frameInit, CElementGraphique objetInit) {
    super (getString("htmlInfoDlg1"), true, frameInit);
    objet = objetInit; 
    initComponents();
    String ch = objet.infoPourHistorique();
    if (objet.estDeNature(NatureObjet.NToutObjet)) {
    	CElementGraphique elg = (CElementGraphique) objet;
    	if (elg.masque) ch += "\n" + getString("ch164");
    }
    if ((!objet.existe) && (objet.getNatureCalcul() == NatureCalcul.NAucunCalcul)) ch = ch + "\n" + getString("ch18");
    if (objet.estElementIntermediaire()) ch = ch + "\n" + getString("ch159");
    else if (objet.estElementFinal) ch = ch + "\n" + getString("ch160");  
    ch += "\n" + getString("Nhtml" ) + " "  + objet.index; // Ajout version 4.9.2 pour communication html
    textArea.setText(ch);
    textArea.setCaretPosition(0);
  }
  private void initComponents() {
    btnOK = new MtgButton(frame, getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });
    JScrollPane scrollPane = new javax.swing.JScrollPane();
    textArea = new MtgTextArea(frame);
    textArea.setColumns(20);
    textArea.setEditable(false);
    textArea.setLineWrap(true);
    textArea.setRows(5);
		textArea.setBorder(BorderFactory.createEmptyBorder(3,3,3,3));		
    scrollPane.setViewportView(textArea);
    // Modification version 5.0 pour tenri compte des crans haute dfinition
    double k = MtgFrame.coefMultForDlgBoxIcons;
    scrollPane.setPreferredSize(new Dimension((int)(k*350), (int)(k*120)));
    
    setModal(true);
    setResizable(false);
    JPanel panePrincipal = new JPanel();
    panePrincipal.setLayout(new BoxLayout(panePrincipal, BoxLayout.X_AXIS));
    panePrincipal.add(textArea);
    panePrincipal.add(btnOK); 
    setContentPane(panePrincipal);
    pack();
  }
  
  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {
  	dispose();
  	frame.activeOutilCapture();
  }                                     

}
