/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;
import java.util.Vector;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class InsertionDynamiqueDansCommentaireDlg extends MtgDlg {
	private int indiceMaxi; // Indice maxi des objest  prsenter dans la list
	private MtgTextArea textArea; // Le textArea dans lequel il faut insrer le code choisi
  private MtgButton btnInsererCode;
  private MtgButton btnCancel;
  private MtgLabel label1;
  private MtgLabel label2;
  private MtgLabel label3;
  private MtgLabel label4;
  private MtgLabel label5;
  private ListeValeursPourInsertionDansCommentaire listeValeursInserables;
  private MtgTextArea infoValeur; // Sert  afficher des infos sur la valeur slectionne dans la liste  
  private MtgTextField infoCode; // Sert  afficher le code  insrer dans le commentaire correspondant au choix fait  
	private PaneListeDecimales paneListeDecimales;
	private MtgCheckBox checkSignePlusImpose;
	private String codeAInserer;
  private MtgFocusTraversalPolicy mtgFocusTraversalPolicy;
  
  public InsertionDynamiqueDansCommentaireDlg(MtgFrame frameInit, int indiceMaxiInit, MtgTextArea textAreaInit) {
    super (getString("dlgInsertionDynamiqueDansCommentaireDlg1"), true, frameInit);
    indiceMaxi = indiceMaxiInit;
    textArea = textAreaInit;
    initComponents();
    getRootPane().setDefaultButton(btnCancel);    
  }

  private void initComponents() {
    btnCancel = new MtgButton(frame, getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed();
      }
    });    
    btnInsererCode = new MtgButton(frame, getString("btnInsererCode"));
    btnInsererCode.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnInsererCodeActionPerformed();
      }
    });
    btnCancel.setMaximumSize(btnInsererCode.getPreferredSize());

    label1 = new MtgLabel(frame, getString("dlgInsertionDynamiqueDansCommentaireDlg2"), JLabel.LEFT);
    label1.setRequestFocusEnabled(false);
    label2 = new MtgLabel(frame, getString("dlgInsertionDynamiqueDansCommentaireDlg3"), JLabel.LEFT);
    label2.setRequestFocusEnabled(false);
    label3 = new MtgLabel(frame, getString("dlgInsertionDynamiqueDansCommentaireDlg4"), JLabel.LEFT);
    label3.setRequestFocusEnabled(false);
    label4 = new MtgLabel(frame, getString("dlgInsertionDynamiqueDansCommentaireDlg5"), JLabel.LEFT);
    label4.setRequestFocusEnabled(false);
    label5 = new MtgLabel(frame, getString("dlgInsertionDynamiqueDansCommentaireDlg6"), JLabel.LEFT);
    label5.setRequestFocusEnabled(false);
    listeValeursInserables = new ListeValeursPourInsertionDansCommentaire(frame, frame.cadreActif().listePr, indiceMaxi);
    listeValeursInserables.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent evt) {
      	listValeursSelectionChanged();
      }
    });
    
    JScrollPane scrollListValeurs = new JScrollPane(listeValeursInserables,
    		JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    infoValeur = new MtgTextArea(frame);
    infoValeur.setEditable(false);
    infoValeur.setColumns(20);
    infoValeur.setEditable(false);
    infoValeur.setLineWrap(false);
    infoValeur.setRows(4);
    JScrollPane scrollPaneInfoValeur = new JScrollPane
    	(infoValeur, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    infoCode = new MtgTextField(frame, 20);
    infoCode.setEditable(false);
 		paneListeDecimales = new PaneListeDecimales(frame, 2);
 		paneListeDecimales.listeDec.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent evt) {
      	listValeursSelectionChanged();
      }
    });
 		checkSignePlusImpose = new MtgCheckBox(frame, getString("dlgInsertionDynamiqueDansCommentaireDlg6"), false);
 		checkSignePlusImpose.addActionListener(new ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				MiseAJourCode();
			}
		});
   
    JPanel pane = new JPanel();
    GridBagLayout gridBag = new GridBagLayout();    
    pane.setLayout(gridBag);
    GridBagConstraints constraints = new GridBagConstraints();
    setConstraints(constraints, 0, 0, 1, 1, 80, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.top = 4;
    constraints.insets.bottom = 4;
    constraints.insets.left = 5;
    constraints.insets.right = 5;

    gridBag.setConstraints(label1, constraints);
    pane.add(label1);
    setConstraints(constraints, 0, 1, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.top = 2;
    constraints.insets.bottom = 2;
    gridBag.setConstraints(label2, constraints);
    pane.add(label2);
    constraints.insets.top = 4;
    constraints.insets.bottom = 4;
    setConstraints(constraints, 0, 2, 1, 3, 0, 40, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    gridBag.setConstraints(scrollListValeurs, constraints);
    pane.add(scrollListValeurs);
    constraints.insets.top = 10;
    constraints.insets.bottom = 2;
    setConstraints(constraints, 0, 5, 2, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    gridBag.setConstraints(label3, constraints);
    pane.add(label3);
    constraints.insets.top = 10;
    setConstraints(constraints, 0, 6, 2, 1, 0, 20, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    gridBag.setConstraints(scrollPaneInfoValeur, constraints);
    pane.add(scrollPaneInfoValeur);
    constraints.insets.bottom = 10;
    setConstraints(constraints, 0, 7, 2, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    gridBag.setConstraints(label4, constraints);
    pane.add(label4);
    constraints.insets.top = 2;
    constraints.insets.bottom = 4;
    setConstraints(constraints, 0, 8, 2, 1, 0, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    gridBag.setConstraints(infoCode, constraints);
    pane.add(infoCode);
    
    JPanel paneDroit = new JPanel(); // Pour mettre les deux boutons en haut et  droite
    paneDroit.setLayout(new BoxLayout(paneDroit,BoxLayout.Y_AXIS));
    paneDroit.add(btnInsererCode);
    paneDroit.add(Box.createRigidArea(new Dimension(0,5)));
    paneDroit.add(btnCancel);
    setConstraints(constraints, 1, 0, 1, 2, 20, 0, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST);
    gridBag.setConstraints(paneDroit, constraints);
    pane.add(paneDroit);
  
    constraints.insets.top = 2;
    setConstraints(constraints, 1, 4, 1, 1, 20, 20, GridBagConstraints.VERTICAL, GridBagConstraints.EAST);
    gridBag.setConstraints(paneListeDecimales, constraints);
    pane.add(paneListeDecimales);
    constraints.insets.top = 4;
    constraints.insets.bottom = 4;
    setConstraints(constraints, 1, 5, 1, 1, 20, 10, GridBagConstraints.VERTICAL, GridBagConstraints.EAST);
    gridBag.setConstraints(checkSignePlusImpose, constraints);
    pane.add(checkSignePlusImpose);
    setConstraints(constraints, 1, 6, 1, 1, 20, 10, GridBagConstraints.VERTICAL, GridBagConstraints.EAST);
    gridBag.setConstraints(label5, constraints);
    pane.add(label5);

    setContentPane(pane);
    getRootPane().setDefaultButton(btnCancel);      
    // On change l'ordre par dfaut des composants
    Vector<Component> order = new Vector<Component>(5);
    order.add(listeValeursInserables);
    order.add(paneListeDecimales.listeDec);
    order.add(checkSignePlusImpose);
    order.add(btnInsererCode);
    order.add(btnCancel);
    mtgFocusTraversalPolicy = new MtgFocusTraversalPolicy(order);
    setFocusTraversalPolicy(mtgFocusTraversalPolicy);
    listValeursSelectionChanged();
    pack();
  }
  
  /**
   * La chaine qui doit dbuter la squence de code.
   * Est redfini par un affichage latex
   * @return
   */
  String debutCode() {
  	return "#Val("; 
  }
  
  /**
   * La chaine qui doit dbuter la squence de code.
   * Est redfini par un affichage latex
   * @return
   */
  String finCode() {
  	return ")"; 
  }
  
  void MiseAJourCode() {
  	codeAInserer = "";  	
  	int ind = listeValeursInserables.getSelectedIndex();
  	if (ind != -1) {
  		String nomValeurSelectionnee = (String) listeValeursInserables.getSelectedValue();
  		boolean affSignePlus = checkSignePlusImpose.isSelected();
  		int nombreDecimales = paneListeDecimales.nombreDecimales();
  		if (nombreDecimales == 2) {
  			codeAInserer = debutCode() + nomValeurSelectionnee;
  			if (affSignePlus) codeAInserer = codeAInserer + ",+" + finCode();
  			else codeAInserer = codeAInserer + finCode();
  		}
  		else {
  			// A revoir version 5.1.2 : Test inutile
  			if (nombreDecimales <= 9)
  				codeAInserer = debutCode() +  nomValeurSelectionnee + "," + Integer.toString(nombreDecimales);
  			else codeAInserer = codeAInserer + debutCode() +  nomValeurSelectionnee + "," + Integer.toString(nombreDecimales);
  			if (affSignePlus) codeAInserer = codeAInserer + ",+" + finCode();
  			else codeAInserer = codeAInserer + finCode();
  		}
  		infoCode.setText(codeAInserer);
  	}
  }
  
  private void miseAJourInfoValeur() {
  	int ind = listeValeursInserables.getSelectedIndex();
  	if (ind != -1) {
  		infoValeur.setText(listeValeursInserables.pointeurs.get(ind).infoPourHistorique());
  		infoValeur.setCaretPosition(0);
  	}
  }
  
  private void listValeursSelectionChanged() {
  	miseAJourInfoValeur();
  	MiseAJourCode();
  	pack();
  }
  
  private void btnCancelActionPerformed() {
  	dispose();
  }
  
  private void btnInsererCodeActionPerformed() {
    int i = textArea.getCaretPosition();
    String ch = textArea.getText();
    String ch2 = ch.substring(0, i) + codeAInserer + ch.substring(i);
    // On informa la fentre propruitaire qu'elle doit si ncessaire remettre  jour
    //l'affichage clignotant (pour CommentaireDlg et LatexDlg)
    MtgDlg owner = (MtgDlg) (textArea.getTopLevelAncestor());
    textArea.setText(ch2);
    textArea.setCaretPosition(i + codeAInserer.length());
    owner.metAJourAffichageClignotant();
    textArea.requestFocus();
    dispose();      	
  }
}
