/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;


import mathgraph32.MtgFrame;
import objets.CFonc;
import objets.CListeObjets;
import types.FonteNom;
import types.NatureCalcul;

@SuppressWarnings("serial")
/**
 * Liste prsentant les fonctions relles disponibles sans les suites
 */
  // Modifi version 4.7.5
public class ListeFonctionsReelles extends ListeObjetsParNatureCalcul {

  public ListeFonctionsReelles(MtgFrame frame, CListeObjets listeInit, int indiceMaxiInit, boolean intermPermisInit) {
    super(frame, listeInit, indiceMaxiInit, NatureCalcul.NFonctionReelle1Variable, intermPermisInit, 6);
		setFont(FonteNom.getFonteEdition(MtgFrame.sizeFontList, FonteNom.Normal,
				(double)frame.pref_addSystemFont/MtgFrame.sizeFontList + MtgFrame.coefMultForSystemFonts));		
  }
  
  public CFonc fonctionSelectionnee() {
  	return (CFonc) elementSelectionne();
  }  
}
