/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.text.NumberFormat;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class PaneNombrePoints extends JPanel {
	private MtgFrame frame;
	public MtgFormattedTextField editeurNombrePoints;
	public int nombrePoints;
	
	public PaneNombrePoints(MtgFrame frameInit, int nombreInit) {
		super();
		frame = frameInit;
		editeurNombrePoints = new MtgFormattedTextField(frame);
    NumberFormat format;
    format = NumberFormat.getInstance();
    format.setParseIntegerOnly(true);
    format.setGroupingUsed(false);
    editeurNombrePoints = new MtgFormattedTextField(frame, format);
    editeurNombrePoints.setColumns(4);
    editeurNombrePoints.setText(Integer.toString(nombreInit));
		MtgLabel label1 = new MtgLabel(frame, MtgFrame.getString("paneNombrePoints2"));
		MtgLabel label2 = new MtgLabel(frame, MtgFrame.getString("paneNombrePoints3"));
		MtgLabel label3 = new MtgLabel(frame, MtgFrame.getString("paneNombrePoints4"));
		
		setLayout(new GridBagLayout());
		
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 2;
    constraints.insets.top = 2;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    add(label1, constraints);
    MtgDlg.setConstraints(constraints, 0, 1, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    add(label2, constraints);
    MtgDlg.setConstraints(constraints, 0, 2, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    add(label3, constraints);
    MtgDlg.setConstraints(constraints, 1, 1, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    add(editeurNombrePoints, constraints);
    setBorder(BorderFactory.createTitledBorder(MtgFrame.getString("paneNombrePoints1")));
	}
	
	public boolean validationNombrePoints() {
		try {
			nombrePoints = Integer.parseInt(editeurNombrePoints.getText());
		}
		catch (NumberFormatException e) {
			frame.dialogueAvertissement(MtgFrame.getString("ch71"));
			editeurNombrePoints.requestFocus();
			return false;
		}
    if ((nombrePoints < 2 ) || nombrePoints > 10000) {
    	frame.dialogueAvertissement(MtgFrame.getString("ch71"));
    	editeurNombrePoints.requestFocus();
    	return false;
    }
    else return true;
	}
	}
