/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;
import javax.swing.JMenuItem;
import actions.MtgAction;
/**
 * Icne destine  tre contenue dans un menu horizontal popup
 * @author Yves 
 *	Modifi version 5.0
 */
@SuppressWarnings("serial")
public class MtgIconItem extends JMenuItem implements ActionListener{
	public MtgAction action;
	public MtgIconButton mtgIconButton;
	public MtgIconItem(MtgAction actionInit, MtgIconButton mtgIconButtonInit) {
		super(getImageIcon(actionInit));
		action = actionInit;
		mtgIconButton = mtgIconButtonInit;
		setIconTextGap(0);
		setText("");
		setToolTipText(action.tip);
		// Ne pas utiliser setBorder quand on utilise le look and feel systme
		// setBorder(BorderFactory.createLineBorder(Color.gray));
    // setBorder(BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(Color.white,1),BorderFactory.createLineBorder(Color.lightGray, 1)));
    addActionListener(this);
	}
	
	public void actionPerformed(ActionEvent e) {
		setVisible(false); // On cache le menu  popup
		if ((action.outilAssocie == null) || action.outilAssocie.activationValide()) {
			// C'est MtgAction.actionPerformed qui se chargera de changer l'icne et de l'activer
			action.actionPerformed(e);
		}
	}
	
  private static final ImageIcon getImageIcon(MtgAction action) {
  	ImageIcon imi = action.imicon;
  	if (imi == null) return null;
  	return new MtgImageIcon(action.frame.coefMultVertIcons(), imi);
  }

}