/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.*;
import types.*;
import mathgraph32.MtgFigurePanel;
import mathgraph32.MtgFrame;

public class OutilDtBis extends OutilPar3pts {
  
  /** Creates a new instance of OutilBis */
  public OutilDtBis(MtgFrame frameInit) {
    super(frameInit);
  }

  
  @Override
  public void creeObjet() {
    CBissectrice pt = new CBissectrice(frame.cadreActif().listePr, null, false, 
       frame.couleurActive(), frame.styleTraitActif(), point1, point2, point3, frame.pref_indiceTaillePoliceNom);
    if (frame.ajouteElementAvecVerification(pt))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil3"));
    annuleClignotement();
    // Provisoire
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  @Override
  public void ajouteObjetsVisuels() {
    CListeObjets liste = frame.listeObjetsVisuels;
    MtgFigurePanel pane = frame.cadreActif().paneFigure;
    CBissectrice bis = new CBissectrice(liste, null, false, frame.couleurActive(),
      frame.styleTraitActif(), point1, point2, pane.pointSouris, 13);
    liste.add(bis);
    CPointProjete ptproj = new CPointProjete(liste, null, false, Couleur.TraduitCouleur(1),
            true, MotifPoint.Croix, point1,bis);
    liste.add(ptproj);
  	// On cre deux segments en pointills
  	CSegment pts1 = new CSegment(liste, null, false, point1, point2);
    liste.add(pts1);
  	CSegment pts2 = new CSegment(liste, null, false, point2, pane.pointSouris);
    liste.add(pts2);
    // On cre deux marques d'angle
    CMarqueAngleGeometrique ptma1 = new CMarqueAngleGeometrique(liste, null, false, 
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais, StyleMarqueAngle.marqueSimple, 11, point1, point2, ptproj);
    liste.add(ptma1);
    CMarqueAngleGeometrique ptma2 = new CMarqueAngleGeometrique(liste, null, false, 
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais, StyleMarqueAngle.marqueSimple, 14, ptproj,
      point2, pane.pointSouris);
    liste.add(ptma2);
  }
    /**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants
   * @param i : l'indice
   * @return
   */

  @Override
  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return getString("bissectrice1");
      case 2 : return getString("bissectrice2");
      case 3 : return getString("bissectrice3");
      default: return "";
    }
  }
  
}