package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CListeObjets;
import objets.CMaxFonc;
import objets.CValeurAssocieeAVariable;
import types.NatureCalcul;
import dialogs.MaximumMinimumDlg;

/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
public class OutilMaximum extends Outil {
  public OutilMaximum(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets liste = cadre.listePr;
    CValeurAssocieeAVariable vala = new CValeurAssocieeAVariable(liste, 0);
    CValeurAssocieeAVariable valb = new CValeurAssocieeAVariable(liste, 0);
    CValeurAssocieeAVariable vale = new CValeurAssocieeAVariable(liste, 0);
    CMaxFonc max = new CMaxFonc(liste, null, false, "", null, vala, valb, vale);    
    MaximumMinimumDlg dlg = new MaximumMinimumDlg(frame, max, false, true);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(max))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil147"));    	
    }
    frame.activeOutilCapture();
  }
  
  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNatureCalcul(NatureCalcul.NFonction) != 0;
	}
	
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeFonction");
	}	
  
}
