/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CListeObjets;
import objets.CSuiteRecComplexe;
import objets.CValeurAssocieeAVariable;
import objets.CValeurAssocieeComp;
import types.NatureCalcul;
import dialogs.SuiteRecurrenteComplexeDlg;

public class OutilSuiteRecurrenteComplexe extends Outil {
  public OutilSuiteRecurrenteComplexe(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets liste = cadre.listePr;
    frame.indication("");
    CSuiteRecComplexe suite = new CSuiteRecComplexe(frame.cadreActif().listePr, new CValeurAssocieeAVariable(liste, 10d),
    		new CValeurAssocieeComp(liste));
    SuiteRecurrenteComplexeDlg dlg = new SuiteRecurrenteComplexeDlg(frame, suite, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(suite))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil74"));    	
    	
    }
    frame.activeOutilCapture();
  }
  
  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NFonctionComplexe) != 0;
	}
		
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeFonctionComplexe");
	}	
  
}
