/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CAffichageLieAPoint;
import objets.CElementGraphique;
import objets.CListeObjets;
import types.NatureObjet;

public class OutilSuppressionLiaisonAffichage extends Outil {
	CAffichageLieAPoint aff;

	public OutilSuppressionLiaisonAffichage(MtgFrame frameInit) {
		super(frameInit, true);
	}

	public void select() {
		super.select();
		aff = null;
		CListeObjets liste = frame.cadreActif().listePr;
		frame.listeClignotante.ajouteAffichagesLiesAPointVisibles(liste);
		frame.outilPointageActif = frame.outilPointageObjetClignotant;
		frame.outilPointageActif.designationDe(NatureObjet.NAffichageLieAPoint);
		frame.indication(getString("suppressionLiaison1"));
		resetClignotement();
	}
	
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (aff == null) {
      aff = (CAffichageLieAPoint) elg;
      annuleClignotement();
      creeObjet();
    }
	}
	
  @Override
	public void creeObjet() {
		MtgInternalFrame cadre = frame.cadreActif();
		CListeObjets liste = cadre.listePr;
		aff.placeNom(aff.pointLie.x + aff.dec_x, aff.pointLie.y + aff.dec_y);
		aff.decaleNom(0,0);
		aff.pointLie = null;
    // Ajout version 4.8.0 : IL faut remettre  jour les index de cahque lment de la liste (CElementBase.index)
    liste.updateIndexes();
    //
    cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil96"));
    cadre.repaintFigureAvecCalcul();
    frame.activeOutilCapture();
    cadre.videListesPourConstructions();  // On remet  jour une construction ventuellement commence
    // liste.initialiseDependances(); // Ajout version 4.8 Supprim version 4.9.2. Fait par GestionnaireEdition.sauvegardeFigureEnCours()
	}
	
  @Override
  public boolean activationValide() {
  	CListeObjets liste = frame.cadreActif().listePr;
    return liste.nombreAffichagesLiesAPointVisibles(true) != 0;
  }
	
}
