package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CUniteyRep;
import types.NatureCalcul;
import dialogs.UniteYDlg;

/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
public class OutilUniteyRep extends Outil {
	public OutilUniteyRep(MtgFrame frameInit) {
		super(frameInit, false); // false car pas de clignotement
	}

  @Override
	public void select() {
  	super.select();
		MtgInternalFrame cadre = frame.cadreActif();
		CUniteyRep unitey = new CUniteyRep(frame.cadreActif().listePr, null, false, "", null);
		UniteYDlg dlg = new UniteYDlg(frame, unitey, false);
		dlg.setLocationRelativeTo(frame);
		dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(unitey))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil153"));    	
    }
    frame.activeOutilCapture();
  }
  
  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)>0;
	}
	
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeRepere");
	}
}
