/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package types;

// Ajout version 4.8.1
import java.awt.Color;
import java.util.Vector;

public class TikzColor {
	public static final String colorString(Color col) {
		int r = col.getRed();
		int g = col.getGreen();
		int b = col.getBlue();
		String rs = Integer.toHexString(r);
		if (rs.length() == 1) rs = "0" + rs;
		String gs = Integer.toHexString(g);
		if (gs.length() == 1) gs = "0" + gs;
		String bs = Integer.toHexString(b);
		if (bs.length() == 1) bs = "0" + bs;
		
		String ch = rs + gs + bs;
		String ch2 = "";
		for (int i = 0; i < 6; i++) {
			char car = ch.charAt(i);
			int code = (int)car;
			if ((code >=48) && (code <= 57)) code += 56;
			ch2 += (char) (code);
		}
		return ch2;
	}
	
	public final static boolean containsColor(Vector<String> vect, Color col) {
		for (int i = 0; i < vect.size(); i++) {
			if (vect.get(i).equals(TikzColor.colorString(col))) return true;
		}
		return false;
	}

}
